#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>



String readString = String(500); //string pour récupérer les données
int adresse;
int adressed=0;
int adresseu=3;
int vitesse=0;
int vitessed;
int vitesseu;
int ma=1;
File webFile;
String myString ;
int f0=0;
int f1=0;
int f2=0;
int f3=0;
int f4=0;
int f5=0;
int f6=0;
int f7=0;
int f8=0;
int f9=0;
int f10=0;
int f11=0;
int f12=0;
int cran=1;




// Les paramètres ci-dessous sont spécifiques à un routeur D-LINK
// Pour un autre réseau il faut les changer
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

byte ip[] = { 192, 168, 0, 102 }; // adresse IP du serveur
byte gateway[] = { 192, 168, 0, 1 }; // passerelle du routeur
byte subnet[] = { 255, 255, 255, 0 }; //masque de sous-réseau

// Initialise la librairie Ethernet

// (port 80 est le port par défaut pour le HTTP):
EthernetServer server(80);

void setup() {
 // Ouvre la communication série
  Serial.begin(9600);
 


  // démarre la communication Ethernet
  Ethernet.begin(mac, ip,gateway, subnet);
  server.begin();
  
  
  // initialise la carte SD
   
    if (!SD.begin(4)) {
      
        return;    // init failed
    }
   
    // check for index.htm file
    if (!SD.exists("index.htm")) {
      
        return;  // can't find index file
    }
   
}




void loop() {
  // attente d'un client smartphone ou tablette
  EthernetClient client = server.available();
  if (client) {
   
      
    // Si un client a bien été récupéré
  
    while (client.connected()) {
     // Si ce client a envoyé des données
      if (client.available()) {
        
        // Lecture de la donnée envoyée caractère par caractère
       
        char c = client.read();
        
 // Ajout progressif des 500 premiers caractères reçus dans la chaine readString
readString += c;
 
    // Si le caractère est un saut de ligne
      
        if (c == '\n') {
          
 
          
          //lit les commandes DCC
          
          // lecture de l'adresse
if(readString.indexOf("adresse=") >=0) {          
int space= readString.indexOf('='); // the space position in the string
char a =  readString.charAt(space + 1) ;
char b =  readString.charAt(space + 2) ;
adressed = int(a)-48;
adresseu = int(b)-48;

}

adresse=10*adressed+adresseu;

          // lecture du cran de vitesse
if(readString.indexOf("cran=") >=0) {          
int space= readString.indexOf('='); // the space position in the string
char d =  readString.charAt(space + 1) ;
cran = int(d)-48;
}


// lecture du sens de marche

if(readString.indexOf("4=mav") >=0) {
  ma=1;

    
}
if(readString.indexOf("4=mar") >=0) {
  ma=0;
 
     
}

// lecture de la vitesse avec l'appli android
if(readString.indexOf("vit=") >=0) {          
int space= readString.indexOf('='); // the space position in the string
char e =  readString.charAt(space + 1) ;

vitesse = 3*(int(e)-48);


}


// lecture de la vitesse avec le navigateur

if(readString.indexOf("5=plus") >=0) {
  vitesse=vitesse+cran;
  
    
}
if(readString.indexOf("5=moins") >=0) {
   vitesse=vitesse-cran;

     
}
if(readString.indexOf("5=STOP") >=0) {
   vitesse=0;
 
     
}
if (vitesse>28) vitesse=28;
if (vitesse<0) vitesse=0;
vitessed=(int)(vitesse/10);
vitesseu=vitesse-10*vitessed;

// lecture des fonctions F0 à F12

if(readString.indexOf("6=F0") >=0) {
f0=1-f0;
    }
if(readString.indexOf("6=F1") >=0) {
f1=1-f1;
    }
if(readString.indexOf("6=F2") >=0) {
f2=1-f2;
    }
if(readString.indexOf("6=F3") >=0) {
f3=1-f3;
    }
if(readString.indexOf("6=F4") >=0) {
f4=1-f4;
    }
if(readString.indexOf("6=F5") >=0) {
f5=1-f5;
    }
if(readString.indexOf("6=F6") >=0) {
f6=1-f6;
    }
if(readString.indexOf("6=F7") >=0) {
f7=1-f7;
    }
if(readString.indexOf("6=F8") >=0) {
f8=1-f8;
    }
if(readString.indexOf("8=F9") >=0) {
f9=1-f9;
    }
if(readString.indexOf("8=F10") >=0) {
f10=1-f10;
    }
if(readString.indexOf("8=F11") >=0) {
f11=1-f11;
    }
if(readString.indexOf("8=F12") >=0) {
f12=1-f12;
    }

if(readString.indexOf("7=ENR_ON") >=0) {
adresse=96;
adressed=9;
adresseu=6;
    }

if(readString.indexOf("7=ENR_OFF") >=0) {
adresse=97;
adressed=9;
adresseu=7;
    }

if(readString.indexOf("7=PLAY_ON") >=0) {
adresse=98;
adressed=9;
adresseu=8;
    }

if(readString.indexOf("7=PLAY_OFF") >=0) {
adresse=99;
adressed=9;
adresseu=9;
    }
    
// transmission des commandes DCC à la station centrale
int fonction1=f1+2*f2+4*f3+8*f4+16*f0;
int fonction1d=(int)(fonction1/10) ;
int fonction1u=fonction1-10*fonction1d ;
int fonction2=f5+2*f6+4*f7+8*f8;
int fonction2d=(int)(fonction2/10) ;
int fonction2u=fonction2-10*fonction2d ;
int fonction3=f9+2*f10+4*f11+8*f12;
int fonction3d=(int)(fonction3/10) ;
int fonction3u=fonction3-10*fonction3d ;
Serial.print(adressed);
Serial.print(adresseu);
Serial.print(ma);
Serial.print(vitessed);
Serial.print(vitesseu);
Serial.print(fonction1d);
Serial.print(fonction1u);
Serial.print(fonction2d);
Serial.print(fonction2u);
Serial.print(fonction3d);
Serial.println(fonction3u);


          // envoi d'un en-tete HTTP standard
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
      
          client.println();
          
          
          // envoi de la page web stockée sur la carte SD
                    webFile = SD.open("index.htm");        // ouvre la page web
                    if (webFile) {
                        while(webFile.available()) {
                            client.write(webFile.read()); // envoie la page web au smartphone
                        }
                        webFile.close();
                    }
                    

// ajout des réponses en bas de la page web

client.print("adresse=");
myString = String(adressed);
client.print(myString);
myString = String(adresseu);
client.print(myString);
client.print("  vitesse=");
myString = String(vitessed);
client.print(myString);
myString = String(vitesseu);
client.println(myString);

// enregistrement de la séquence

if (adresse==96){
client.println("enregistrement en cours"); 
}
if (adresse==97){
client.println("enregistrement termine");   
}



// lecture de la séquence enregistrée

if (adresse==98){
client.println("commande automatique en cours"); 
}
if (adresse==99 ){
client.println("fin de la commande automatique");   
}

break;
        }
        
      }
    }

    
   
    
    delay(100);
    //vide le string
    readString = "";
    
    // ferme la connection
    client.stop();
   
   
  }
}
